package eu.maiora.model

import com.example.db.*
import org.jetbrains.exposed.sql.SqlExpressionBuilder.eq
import org.jetbrains.exposed.sql.deleteWhere

class LogScriptRepositoryImpl : LogScriptRepository {
    override suspend fun allLogScript(): List<LogScript> = suspendTransaction {
        LogScriptDAO.all().map(::logScriptDaoToModel)
    }

    override suspend fun logScriptById(id: Int): LogScript? = suspendTransaction {
        LogScriptDAO.findById(id)?.let { logScriptDaoToModel(it) }
    }

    override suspend fun editLogScript(logScript: LogScript): Boolean = suspendTransaction {
        val logScriptDao = LogScriptDAO.findById(logScript.id)

        if (logScriptDao != null) {
            logScriptDao.script_elaborato = logScript.script_elaborato
            true
        } else {
            false
        }
    }

    /*override suspend fun taskByName(name: String): Task? = suspendTransaction {
        TaskDAO
            .find { (TaskTable.name eq name) }
            .limit(1)
            .map(::daoToModel)
            .firstOrNull()
    }

    override suspend fun addTask(task: Task): Unit = suspendTransaction {
        TaskDAO.new {
            name = task.name
            description = task.description
            priority = task.priority.toString()
        }
    }

    override suspend fun removeTask(name: String): Boolean = suspendTransaction {
        val rowsDeleted = TaskTable.deleteWhere {
            TaskTable.name eq name
        }
        rowsDeleted == 1
    }*/


}