package eu.maiora.plugins

import eu.maiora.model.LogScriptRepositoryImpl
import eu.maiora.routes.analizzaURLRoute
import eu.maiora.routes.eseguiScriptSQLRoute
import eu.maiora.routes.logScriptRouting
import io.ktor.server.application.*
import io.ktor.server.response.*
import io.ktor.server.routing.*

fun Application.configureRouting(dbUrl : String, username : String, password : String, repository : LogScriptRepositoryImpl ) {
    routing {
        get("/") {
            call.respondText("Hello World!")
        }

        analizzaURLRoute()
        eseguiScriptSQLRoute(dbUrl, username, password)
        logScriptRouting(repository)
    }
}
