package eu.maiora.routes

import io.ktor.http.*
import java.sql.Connection
import io.ktor.server.application.*
import io.ktor.server.request.*
import io.ktor.server.response.*
import io.ktor.server.routing.*
import kotlinx.serialization.Serializable
import org.slf4j.LoggerFactory
import java.sql.DriverManager
import java.time.Instant
import java.time.format.DateTimeFormatter

fun Route.eseguiScriptSQLRoute(dbUrl : String, username : String, password : String) {
    post("/eseguiScriptSQL") {
        // Riceve il body della richiesta e lo deserializza in ReceivedResponse
        val receivedResponse = try {
            call.receive<ReceivedResponse>()
        } catch (e: Exception) {
            return@post call.respondText("Body mancante " + e.stackTraceToString(), status = HttpStatusCode.BadRequest)
        }
        val logger = LoggerFactory.getLogger("LogScriptRoute")
        logger.info("instructions: " +
                 receivedResponse.instructions);


        val connection: Connection = DriverManager.getConnection(dbUrl, username, password)
        val statement = connection.createStatement()

        val sqlInsert = "INSERT INTO aipoc.log_script(id,ts_ricezione, script_ricevuto, script_elaborato) VALUES (" +
                "NEXTVAL('aipoc.seq_log_script'), " +
                "'" + DateTimeFormatter.ISO_INSTANT.format(Instant.now()).toString() + "', " +
                "'" +receivedResponse.instructions + "', " +
                "'" +receivedResponse.instructions + "') RETURNING id"

        val resultSet = statement.executeQuery(sqlInsert)
        val results = mutableListOf<Map<String, Any>>()

        val metaData = resultSet.metaData
        val columnCount = metaData.columnCount
        while (resultSet.next()) {
            val row = mutableMapOf<String, Any>()
            for (i in 1..columnCount) {
                row[metaData.getColumnName(i)] = resultSet.getObject(i)
            }
            results.add(row)
        }

        resultSet.close()
        statement.close()
        connection.close()
        call.respondText("receivedResponse: ${results}", status = HttpStatusCode.OK);
    }

}

@Serializable
data class ReceivedResponse(val instructions: String)